import{s as Ce,f as D,n as He,o as $e}from"../chunks/scheduler.37c15a92.js";import{S as be,i as Qe,g as n,s as i,r as _e,m as De,A as Ne,h as r,f as s,c as o,j as ye,u as Te,x as l,n as je,k as p,y as Ie,a,v as xe,d as ke,t as Le,w as Me}from"../chunks/index.7cb9c9b8.js";import{H as Pe}from"../chunks/Heading.d3928e2a.js";function qe(te){let u,N,b,j,m,I,c,se="This is the architecture of our Deep Q-Learning network:",q,h,ae,W,g,ne="As input, we take a <strong>stack of 4 frames</strong> passed through the network as a state and output a <strong>vector of Q-values for each possible action at that state</strong>. Then, like with Q-Learning, we just need to use our epsilon-greedy policy to select which action to take.",z,f,ie="When the Neural Network is initialized, <strong>the Q-value estimation is terrible</strong>. But during training, our Deep Q-Network agent will associate a situation with the appropriate action and <strong>learn to play the game well</strong>.",G,d,A,w,re="We need to <strong>preprocess the input</strong>. It’s an essential step since we want to <strong>reduce the complexity of our state to reduce the computation time needed for training</strong>.",B,v,oe=`To achieve this, we <strong>reduce the state space to 84x84 and grayscale it</strong>. We can do this since the colors in Atari environments don’t add important information.
This is a big improvement since we <strong>reduce our three color channels (RGB) to 1</strong>.`,E,_,le=`We can also <strong>crop a part of the screen in some games</strong> if it does not contain important information.
Then we stack four frames together.`,S,y,pe,R,T,ue=`<strong>Why do we stack four frames together?</strong>
We stack frames together because it helps us <strong>handle the problem of temporal limitation</strong>. Let’s take an example with the game of Pong. When you see this frame:`,U,x,me,F,k,ce=`Can you tell me where the ball is going?
No, because one frame is not enough to have a sense of motion! But what if I add three more frames? <strong>Here you can see that the ball is going to the right</strong>.`,Y,L,he,J,M,ge="Then the stacked frames are processed by three convolutional layers. These layers <strong>allow us to capture and exploit spatial relationships in images</strong>. But also, because the frames are stacked together, <strong>we can exploit some temporal properties across those frames</strong>.",K,P,fe='If you don’t know what convolutional layers are, don’t worry. You can check out <a href="https://www.udacity.com/course/deep-learning-pytorch--ud188" rel="nofollow">Lesson 4 of this free Deep Learning Course by Udacity</a>',O,C,de="Finally, we have a couple of fully connected layers that output a Q-value for each possible action at that state.",V,H,we,X,$,ve="So, we see that Deep Q-Learning uses a neural network to approximate, given a state, the different Q-values for each possible action at that state. Now let’s study the Deep Q-Learning algorithm.",Z,Q,ee;return m=new Pe({props:{title:"The Deep Q-Network (DQN)",local:"deep-q-network",headingTag:"h1"}}),d=new Pe({props:{title:"Preprocessing the input and temporal limitation",local:"preprocessing",headingTag:"h2"}}),{c(){u=n("meta"),N=i(),b=n("p"),j=i(),_e(m.$$.fragment),I=i(),c=n("p"),c.textContent=se,q=i(),h=n("img"),W=i(),g=n("p"),g.innerHTML=ne,z=i(),f=n("p"),f.innerHTML=ie,G=i(),_e(d.$$.fragment),A=i(),w=n("p"),w.innerHTML=re,B=i(),v=n("p"),v.innerHTML=oe,E=i(),_=n("p"),_.innerHTML=le,S=i(),y=n("img"),R=i(),T=n("p"),T.innerHTML=ue,U=i(),x=n("img"),F=i(),k=n("p"),k.innerHTML=ce,Y=i(),L=n("img"),J=De(`
That’s why, to capture temporal information, we stack four frames together.
`),M=n("p"),M.innerHTML=ge,K=i(),P=n("p"),P.innerHTML=fe,O=i(),C=n("p"),C.textContent=de,V=i(),H=n("img"),X=i(),$=n("p"),$.textContent=ve,Z=i(),Q=n("p"),this.h()},l(e){const t=Ne("svelte-u9bgzb",document.head);u=r(t,"META",{name:!0,content:!0}),t.forEach(s),N=o(e),b=r(e,"P",{}),ye(b).forEach(s),j=o(e),Te(m.$$.fragment,e),I=o(e),c=r(e,"P",{"data-svelte-h":!0}),l(c)!=="svelte-1jlvrsz"&&(c.textContent=se),q=o(e),h=r(e,"IMG",{src:!0,alt:!0}),W=o(e),g=r(e,"P",{"data-svelte-h":!0}),l(g)!=="svelte-1hypp4p"&&(g.innerHTML=ne),z=o(e),f=r(e,"P",{"data-svelte-h":!0}),l(f)!=="svelte-1k6czvr"&&(f.innerHTML=ie),G=o(e),Te(d.$$.fragment,e),A=o(e),w=r(e,"P",{"data-svelte-h":!0}),l(w)!=="svelte-1lyhjdo"&&(w.innerHTML=re),B=o(e),v=r(e,"P",{"data-svelte-h":!0}),l(v)!=="svelte-3unddj"&&(v.innerHTML=oe),E=o(e),_=r(e,"P",{"data-svelte-h":!0}),l(_)!=="svelte-12atbxn"&&(_.innerHTML=le),S=o(e),y=r(e,"IMG",{src:!0,alt:!0}),R=o(e),T=r(e,"P",{"data-svelte-h":!0}),l(T)!=="svelte-1d5ylzm"&&(T.innerHTML=ue),U=o(e),x=r(e,"IMG",{src:!0,alt:!0}),F=o(e),k=r(e,"P",{"data-svelte-h":!0}),l(k)!=="svelte-1gpzepb"&&(k.innerHTML=ce),Y=o(e),L=r(e,"IMG",{src:!0,alt:!0}),J=je(e,`
That’s why, to capture temporal information, we stack four frames together.
`),M=r(e,"P",{"data-svelte-h":!0}),l(M)!=="svelte-1qrirkm"&&(M.innerHTML=ge),K=o(e),P=r(e,"P",{"data-svelte-h":!0}),l(P)!=="svelte-7233xh"&&(P.innerHTML=fe),O=o(e),C=r(e,"P",{"data-svelte-h":!0}),l(C)!=="svelte-2hryy8"&&(C.textContent=de),V=o(e),H=r(e,"IMG",{src:!0,alt:!0}),X=o(e),$=r(e,"P",{"data-svelte-h":!0}),l($)!=="svelte-2wm1wc"&&($.textContent=ve),Z=o(e),Q=r(e,"P",{}),ye(Q).forEach(s),this.h()},h(){p(u,"name","hf:doc:metadata"),p(u,"content",We),D(h.src,ae="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/deep-q-network.jpg")||p(h,"src",ae),p(h,"alt","Deep Q Network"),D(y.src,pe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/preprocessing.jpg")||p(y,"src",pe),p(y,"alt","Preprocessing"),D(x.src,me="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/temporal-limitation.jpg")||p(x,"src",me),p(x,"alt","Temporal Limitation"),D(L.src,he="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/temporal-limitation-2.jpg")||p(L,"src",he),p(L,"alt","Temporal Limitation"),D(H.src,we="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/deep-q-network.jpg")||p(H,"src",we),p(H,"alt","Deep Q Network")},m(e,t){Ie(document.head,u),a(e,N,t),a(e,b,t),a(e,j,t),xe(m,e,t),a(e,I,t),a(e,c,t),a(e,q,t),a(e,h,t),a(e,W,t),a(e,g,t),a(e,z,t),a(e,f,t),a(e,G,t),xe(d,e,t),a(e,A,t),a(e,w,t),a(e,B,t),a(e,v,t),a(e,E,t),a(e,_,t),a(e,S,t),a(e,y,t),a(e,R,t),a(e,T,t),a(e,U,t),a(e,x,t),a(e,F,t),a(e,k,t),a(e,Y,t),a(e,L,t),a(e,J,t),a(e,M,t),a(e,K,t),a(e,P,t),a(e,O,t),a(e,C,t),a(e,V,t),a(e,H,t),a(e,X,t),a(e,$,t),a(e,Z,t),a(e,Q,t),ee=!0},p:He,i(e){ee||(ke(m.$$.fragment,e),ke(d.$$.fragment,e),ee=!0)},o(e){Le(m.$$.fragment,e),Le(d.$$.fragment,e),ee=!1},d(e){e&&(s(N),s(b),s(j),s(I),s(c),s(q),s(h),s(W),s(g),s(z),s(f),s(G),s(A),s(w),s(B),s(v),s(E),s(_),s(S),s(y),s(R),s(T),s(U),s(x),s(F),s(k),s(Y),s(L),s(J),s(M),s(K),s(P),s(O),s(C),s(V),s(H),s(X),s($),s(Z),s(Q)),s(u),Me(m,e),Me(d,e)}}}const We='{"title":"The Deep Q-Network (DQN)","local":"deep-q-network","sections":[{"title":"Preprocessing the input and temporal limitation","local":"preprocessing","sections":[],"depth":2}],"depth":1}';function ze(te){return $e(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ee extends be{constructor(u){super(),Qe(this,u,ze,qe,Ce,{})}}export{Ee as component};
